# DescribeNetworkLoadBalancers - DescribeNetworkLoadBalancers

## Overview

DescribeNetworkLoadBalancers






## Definition

### Public Parameters

| Parameter Name | Type | Description Information | Required |
|:---|:---|:---|:---|
| **Action**     | string  | Corresponding API command name, the current API is `DescribeNetworkLoadBalancers`.                      | **Yes** |
| **PublicKey**  | string  | The user's public key can be obtained from [Console](https://console.genesissai.com/uaccount/api_manage)                                             | **Yes** |
| **Signature**  | string  | User signature generated based on public key and API command, see [Signature Algorithm](/docs/api/summary/signature.md)  | **Yes** |

### Request Parameters

| Parameter Name | Type | Description Information | Required |
|:---|:---|:---|:---|
| **Region** | string | Region. See [Region and Zone List](/docs/api/summary/regionlist) |**Yes**|
| **ProjectId** | string | Project ID. Leave it blank for the default project. Sub-accounts must fill in. Please refer to the [GetProjectList API](/docs/api/summary/get_project_list) |No|
| **ShowDetail** | boolean | Do you want to get detailed information about the listener and backend service nodes? |No|
| **NLBIds.N** | string | ID of the load balancing instance, array |No|
| **VPCId** | string | Specify the VPC location |No|
| **SubnetId** | string | Specify the subnet |No|
| **Offset** | int | Data offset, default is 0 |No|
| **Limit** | int | Data pagination value, default is 100 |No|

### Response Field

| Field Name | Type | Description Information | Required |
|:---|:---|:---|:---|
| **RetCode** | int | Return status code. If it is 0, it means successful return. If it is not 0, it means failure. |**Yes**|
| **Action** | string | Operation command name. |**Yes**|
| **Message** | string | Returns an error message, providing detailed description when `RetCode` is non-zero. |No|
| **TotalCount** | int | Total number of load balancing instances that meet the conditions |**Yes**|
| **NLBs** | array[[*NetworkLoadBalancer*](#networkloadbalancer)] | Returned load balance instance list |**Yes**|

#### Data Model


#### NetworkLoadBalancer

| Field Name | Type | Description Information | Required |
|:---|:---|:---|:---|
| **NLBId** | string | ID of the Load Balancing Instance |No|
| **Name** | string | Name of the Load Balancing Instance |No|
| **Tag** | string | The Business Group ID to which the Load Balancer instance belongs |No|
| **Remark** | string | Remarks information of the load balancing instance |No|
| **IPVersion** | string | Supported IP protocol version for Load Balancer instance |No|
| **VPCId** | string | The Resource ID of the VPC to which the Load Balancer instance belongs |No|
| **SubnetId** | string | Subnet resource ID to which the load balancing instance belongs |No|
| **IPInfos** | array[[*IPInfo*](#ipinfo)] | Bound IP Information |No|
| **ForwardingMode** | string | Forwarding mode of the load balancing instance |No|
| **ChargeType** | string | Payment Mode |No|
| **PurchaseValue** | int | Validity Period (Billing) |No|
| **CreateTime** | int | Load balancing instance creation time. The format is Unix Timestamp. |No|
| **Listeners** | array[[*Listener*](#listener)] |  |No|
| **Status** | string | NLB Status: Normal-Normal; Arrears-Service suspended due to arrears |No|
| **AutoRenewEnabled** | boolean | Enable auto-renewal |No|

#### IPInfo

| Field Name | Type | Description Information | Required |
|:---|:---|:---|:---|
| **Id** | string | Unique Identifier ID |No|
| **IP** | string | IP Address |No|
| **Type** | int | IP Type, 1 (Forward IP) / 2 (Backward IP) |No|
| **IPVersion** | string | IP Protocol Version, limited enumeration values: "IPv4" / "IPv6"  |No|
| **AddressType** | string | Network mode, limited enumeration values: "Internet" / "Intranet". |No|
| **OperatorName** | string | ISP information of the public IP, limited enumeration values: "Telecom" / "Unicom"/"International"/"Bgp"/"Duplet"/"BGPPro"/"China-mobile"/"Anycast". |No|
| **BandwidthType** | int | Bandwidth type, limited enumeration values: 0 (Ordinary bandwidth) / 1 (Shared bandwidth) |No|
| **Bandwidth** | int | Bandwidth value. Unit M |No|

#### Listener

| Field Name | Type | Description Information | Required |
|:---|:---|:---|:---|
| **ListenerId** | string | Listener's ID |No|
| **Name** | string | Name of the Listener |No|
| **Remark** | string | Remarks on the Listener |No|
| **StartPort** | int | Start port of the port range |No|
| **EndPort** | int | End port of the port range |No|
| **Protocol** | string | Monitoring protocol, limited to the values: "TCP"/"UDP". |No|
| **Scheduler** | string | Load balancing algorithm, limited values: "RoundRobin"/"SourceHash"/"LeastConn"/"WeightLeastConn "/"WeightRoundRobin " |No|
| **StickinessTimeout** | int | Session keep-alive timeout. Unit: seconds, 0 means session keep-alive is not enabled. |No|
| **ForwardSrcIPMethod** | string | Method of transmitting source IP. Limited values: "" / "None" / "Toa", empty string and None represent closed. |No|
| **HealthCheckConfig** | [*HealthCheckConfig*](#healthcheckconfig) | Health Check Related Configuration |No|
| **Targets** | array[[*Target*](#target)] | Service Node Information |No|
| **State** | string | Listener health status, "Healthy"/"Unhealthy"/"PartialHealth"/"None". |No|
| **DeletionProtection** | boolean | Enable delete protection |No|

#### HealthCheckConfig

| Field Name | Type | Description Information | Required |
|:---|:---|:---|:---|
| **Enabled** | boolean | Whether to enable the health check function. |No|
| **Port** | int | Health Check Probe Port<br />Note:<br />Limited value range: [1-65535] |No|
| **Type** | string | Health Check Method<br />Limited values: "Port"/"UDP"/"Ping"/"HTTP"<br />Default value: “Port” |No|
| **Interval** | int | Health Check Interval Time<br />Limited value range: [1-60] in seconds<br />Default is 2s |No|
| **MinSuccess** | int | Minimum Health Check Successes<br />Limited value range: [1-10]<br />Default 3 |No|
| **MaxFail** | int | Maximum Health Check Failures<br />Limited value range: [1-10]<br />Default 3 |No|
| **ReqMsg** | string | Request string for "UDP" check mode<br />Request json string for "HTTP" check mode |No|
| **ResMsg** | string | Expected response string for 'UDP' check mode<br />Response status code for 'HTTP' check mode |No|

#### Target

| Field Name | Type | Description Information | Required |
|:---|:---|:---|:---|
| **Region** | string | Service Node Location |No|
| **ResourceType** | string | Type of service node |No|
| **ResourceId** | string | Resource ID of the service node. Must be passed when not of IP type. |No|
| **ResourceName** | string | Resource Name of Service Node |No|
| **VPCId** | string | The VPC resource ID of the service node. It is required when the IP type is passed. |No|
| **SubnetId** | string | The subnet resource ID of the service node. Must be passed when the IP type is used. |No|
| **ResourceIP** | string | IP of the service node. Must be provided when the IP type is set. |No|
| **Port** | int | Port of the service node |No|
| **Weight** | int | The weight of the service node. Support for updates. |No|
| **Enabled** | boolean | Is the service node enabled? |No|
| **Id** | string | Service node identification ID<br />Description:<br />No need to pass when adding a service node<br />Must pass when updating service node attributes |No|
| **State** | string | Health check status of the service node<br />Note:<br />Displayed when describing service node information<br />Limited enumeration values: "Healthy"/"Unhealthy". |No|

## Example

### Request Example
    
```
https://api.genesissai.com/?Action=DescribeNetworkLoadBalancers
&Region=cn-zj
&Zone=cn-zj-01
&ProjectId=XWnVXDaH
&ForwardingMode=fmjZHeSw
&ShowDetail=true
&NLBIds=fCoyYvnX
&VPCId=SNnuSFGY
&SubnetId=bDacFudp
&Offset=3
&Limit=9
```

### Response Example
    
```json
{
  "Action": "DescribeNetworkLoadBalancersResponse",
  "NLBs": [
    {
      "AutoRenewEnabled": false,
      "ChargeType": "aljeUkow",
      "CreateTime": 9,
      "ForwardingMode": "IpUKAiWW",
      "IPInfos": [
        {
          "Id": "ItnGLdAu"
        }
      ],
      "IPVersion": "GZZZWxKd",
      "Listeners": [
        {
          "ListenerId": "EVzmnRSu"
        }
      ],
      "LoadBalancerId": "ALcsXnSb",
      "Name": "XQhsmXrC",
      "PurchaseValue": 5,
      "Remark": "FkKQmERh",
      "Status": "MUXVamxX",
      "SubnetId": "UAcSxGRB",
      "Tag": "DbTcdEvu",
      "VPCId": "WnqetCLB"
    }
  ],
  "RetCode": 0,
  "TotalCount": 3
}
```





